function [x, iter, time] = jac(A,b, x0, tol)

% SOLUTION serie 7 ex. 3a, NumMath FS14
%
% jacobi to solve linear system A*x=b
% in:	A	matrix of linear system
%	b	right hand side of system
%	x0	initial guess
%	tol	tolerance for convergence
% out:	x	approximative solution 
%	iter	number of iterations needed
% 	time	cpu time needed

tic
 D=diag(diag(A));
 L=tril(A)-D;
 R=triu(A)-D;
 x=x0; % start with initial guess
 maxIter=2e3; iter=0;
 while (iter<maxIter)
  iter=iter+1;
  xold=x;
  x=D\((-L-R)*x+b); % Jacobi iteration without inverse
  if (norm(x-xold)<norm(x)*tol+tol) break; end % converged!
 end
 time=toc;
 if (iter==maxIter)
  disp(['no convergence after ',int2str(iter),' iterations']);
 end;
